library ieee;
use ieee.std_logic_1164.all;

entity Adder is
	generic (
		NBits : integer := 16
	);
	port (
		A : in std_logic_vector((NBits - 1) downto 0);
		B : in std_logic_vector((NBits - 1) downto 0);
		Y : out std_logic_vector((NBits - 1) downto 0)
	);
end Adder;

architecture Architecture1 of Adder is
	component FullAdder is
		port (
			A    : in std_logic;
			B    : in std_logic;
			Cin  : in std_logic;
			Y    : out std_logic;
			Cout : out std_logic
		);
	end component;
	signal InternalCarry : std_logic_vector(NBits downto 0);
begin
	AdderSet : for I in 0 to (NBits - 1) generate
	begin
		Ai : FullAdder port map (
			A => A(I),
			B => B(I),
			Cin => InternalCarry(I),
			Y => Y(I),
			Cout => InternalCarry(I + 1)
		);
	end generate;
	InternalCarry(0) <= '0';
end Architecture1;
