library ieee;
use ieee.std_logic_1164.all;

entity Mux3Inputs is
	generic (
		NBits : integer := 16
	);
	port (
		Sel     : in std_logic_vector(1 downto 0);
		DataIn0 : in std_logic_vector((NBits - 1) downto 0);
		DataIn1 : in std_logic_vector((NBits - 1) downto 0);
		DataIn2 : in std_logic_vector((NBits - 1) downto 0);
		DataOut : out std_logic_vector((NBits - 1) downto 0)
	);
end entity;

architecture Architecture1 of Mux3Inputs is
begin
	DataOut <= DataIn0 when (Sel = "00") else
	           DataIn1 when (Sel = "01") else
	           DataIn2;
end architecture;
