library ieee;
use ieee.std_logic_1164.all;

entity Mux6Inputs is
	generic (
		NBits : integer := 16
	);
	port (
		Sel     : in std_logic_vector(2 downto 0);
		DataIn0 : in std_logic_vector((NBits - 1) downto 0);
		DataIn1 : in std_logic_vector((NBits - 1) downto 0);
		DataIn2 : in std_logic_vector((NBits - 1) downto 0);
		DataIn3 : in std_logic_vector((NBits - 1) downto 0);
		DataIn4 : in std_logic_vector((NBits - 1) downto 0);
		DataIn5 : in std_logic_vector((NBits - 1) downto 0);
		DataOut : out std_logic_vector((NBits - 1) downto 0)
	);
end entity;

architecture Architecture1 of Mux6Inputs is
begin
	DataOut <= DataIn0 when (Sel = "000") else
	           DataIn1 when (Sel = "001") else
	           DataIn2 when (Sel = "010") else
	           DataIn3 when (Sel = "011") else
	           DataIn4 when (Sel = "100") else
	           DataIn5;
end architecture;
