library IEEE;
use IEEE.std_logic_1164.all;

entity Neg is
	generic (
		NBits : integer := 16
	);
	port(
		DataIn  : in std_logic_vector((NBits - 1) downto 0);
		DataOut : out std_logic_vector((NBits - 1) downto 0)
	);
end Neg;

architecture Architecture1 of Neg is
	component C2Element
		port(
    		BitIn  : in std_logic;
      		Cin    : in std_logic;
        	BitOut : out std_logic;
        	Cout   : out std_logic
		);
    end component;
    signal InternalCarry : std_logic_vector(NBits downto 0);
begin
	C2Block : for N in 0 to (NBits - 1) generate
		C2 : C2Element
			port map (
				BitIn => DataIn(N),
				BitOut => DataOut(N),
				Cin => InternalCarry(N),
				Cout => InternalCarry(N + 1)
			);
	end generate;
    InternalCarry(0) <= '0';
end Architecture1;
