library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity Ram is
	port (
		AddressIn   : in std_logic_vector(12 downto 0);
		DataOut     : out std_logic_vector(15 downto 0);
		DataIn      : in std_logic_vector(15 downto 0);
		WriteEnable : in std_logic;
		Enable      : in std_logic;
		Clk         : in std_logic
	);
end entity;

architecture Architecture1 of Ram is
	type RamType is array(0 to 8191) of std_logic_vector(15 downto 0);
	signal Data : RamType;
begin
	process (Clk)
	begin
		if ((Clk'event) and (Clk = '1')) then
			if (Enable = '1') then
				if (WriteEnable = '1') then
					Data(to_integer(unsigned(AddressIn))) <= DataIn;
				end if;
				DataOut <= Data(to_integer(unsigned(AddressIn)));
			end if;
		end if;
	end process;
end architecture;
