library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity Rom is
	port (
		AddressIn : in std_logic_vector(12 downto 0);
		DataOut   : out std_logic_vector(15 downto 0)
	);
end entity;

architecture Architecture1 of Rom is
type RomType is array (0 to 8191) of std_logic_vector(15 downto 0);
constant Data : RomType := (

	                       --     ; [12288] <-- 0
	"1011000000000000",    --     loadi 12288
	"0010000100000000",    --     op rb, ra, assign
	"1000000000000000",    --     loadi 0
	"0011000000000000",    --     store
	                       -- loop:
	                       --     ; RA <-- [12288]
	"1011000000000000",    --     loadi 12288
	"0010000100000000",    --     op rb, ra, assign
	"0001000000000000",    --     load
	                       --     ; RA <-- NOT RA
	"0010000000000110",    --     op ra, ra, not
	                       --     ; [12288] <-- RA
	"0011000000000000",    --     store
	                       --     ; wait loop
	"1000000000000011",    --     loadi 3
	"0010000100000000",    --     op rb, ra, assign
	                       -- waitLoop1:
	"0010000000010000",    --     op ra, rb, assign
	"0111000000000110",    --     jz waitLoop1End       (+6)
	"1000000000000011",    --     loadi 3
	                       -- waitLoop2:
	"0111000000000010",    --     jz waitLoop2End       (+2)
	"0010000000001000",    --     op ra, ra, dec
	"0110111111111101",    --     j waitLoop2           (-3)
	                       -- waitLoop2End:
	"0010000100011000",    --     op rb, rb, dec
	"0110111111111000",    --     j waitLoop1           (-8)
	                       -- waitLoop1End:
	"0110111111110000",    --     j loop                (-16)

	others => "0000000000000000"
);
begin
	DataOut <= Data(to_integer(unsigned(AddressIn)));
end architecture;
