library ieee;
use ieee.std_logic_1164.all;

entity SignExp is
	generic (
		NBitsToExpand0 : integer := 15;
		NBitsToExpand1 : integer := 12;
		NBits : integer := 16
	);
	port (
		SelIn   : in std_logic;
		DataIn  : in std_logic_vector((NBits - 1) downto 0);
		DataOut : out std_logic_vector((NBits - 1) downto 0)
	);
end SignExp;

architecture Architecture1 of SignExp is
signal Expansion0 : std_logic_vector((NBits - NBitsToExpand0 - 1) downto 0);
signal Expansion1 : std_logic_vector((NBits - NBitsToExpand1 - 1) downto 0);
begin
	Expansion0 <= (others => DataIn(NBitsToExpand0 - 1));
	Expansion1 <= (others => DataIn(NBitsToExpand1 - 1));
	DataOut <= Expansion0 & DataIn((NBitsToExpand0 - 1) downto 0) when (SelIn = '0') else
	           Expansion1 & DataIn((NBitsToExpand1 - 1) downto 0);
end Architecture1;
