library ieee;
use ieee.std_logic_1164.all;

entity V1 is
	port (
		Clk   : in std_logic;
		Reset : in std_logic;
		GPOut : out std_logic_vector(15 downto 0)
	);
end entity;

architecture Architecture1 of V1 is
	component AllButFSM is
		port (
			DataOutEnable  : in std_logic;
			DataInEnable   : in std_logic;
			RAEnable       : in std_logic;
			RBEnable       : in std_logic;
			RCEnable       : in std_logic;
			SPEnable       : in std_logic;
			PCEnable       : in std_logic;
			AddrEnable     : in std_logic;
			IREnable       : in std_logic;
			Mux1Sel        : in std_logic_vector(1 downto 0);
			Mux2Sel        : in std_logic_vector(1 downto 0);
			Mux3Sel        : in std_logic_vector(2 downto 0);
			Mux4Sel        : in std_logic_vector(2 downto 0);
			Mux5Sel        : in std_logic;
			Mux6Sel        : in std_logic;
			AluOpSel       : in std_logic_vector(3 downto 0);
			MemWriteEnable : in std_logic;
			SignExpSel     : in std_logic;
			IRValue        : out std_logic_vector(15 downto 0);
			GPOut          : out std_logic_vector(15 downto 0);
			Clk            : in std_logic;
			Reset          : in std_logic
		);
	end component;
	component FSM is
		port (
			DataOutEnable  : out std_logic;
			DataInEnable   : out std_logic;
			RAEnable       : out std_logic;
			RBEnable       : out std_logic;
			RCEnable       : out std_logic;
			SPEnable       : out std_logic;
			PCEnable       : out std_logic;
			AddrEnable     : out std_logic;
			IREnable       : out std_logic;
			Mux1Sel        : out std_logic_vector(1 downto 0);
			Mux2Sel        : out std_logic_vector(1 downto 0);
			Mux3Sel        : out std_logic_vector(2 downto 0);
			Mux4Sel        : out std_logic_vector(2 downto 0);
			Mux5Sel        : out std_logic;
			Mux6Sel        : out std_logic;
			AluOpSel       : out std_logic_vector(3 downto 0);
			MemWriteEnable : out std_logic;
			SignExpSel     : out std_logic;
			IRValue        : in std_logic_vector(15 downto 0);
			Clk            : in std_logic;
			Reset          : in std_logic
		);
	end component;
	signal AuxDataOutEnable  : std_logic;
	signal AuxDataInEnable   : std_logic;
	signal AuxRAEnable       : std_logic;
	signal AuxRBEnable       : std_logic;
	signal AuxRCEnable       : std_logic;
	signal AuxSPEnable       : std_logic;
	signal AuxPCEnable       : std_logic;
	signal AuxAddrEnable     : std_logic;
	signal AuxIREnable       : std_logic;
	signal AuxMux1Sel        : std_logic_vector(1 downto 0);
	signal AuxMux2Sel        : std_logic_vector(1 downto 0);
	signal AuxMux3Sel        : std_logic_vector(2 downto 0);
	signal AuxMux4Sel        : std_logic_vector(2 downto 0);
	signal AuxMux5Sel        : std_logic;
	signal AuxMux6Sel        : std_logic;
	signal AuxAluOpSel       : std_logic_vector(3 downto 0);
	signal AuxMemWriteEnable : std_logic;
	signal AuxSignExpSel     : std_logic;
	signal AuxIRValue        : std_logic_vector(15 downto 0);
begin
	AllButFSM1 : AllButFSM port map (
		DataOutEnable  => AuxDataOutEnable,
		DataInEnable   => AuxDataInEnable,
		RAEnable       => AuxRAEnable,
		RBEnable       => AuxRBEnable,
		RCEnable       => AuxRCEnable,
		SPEnable       => AuxSPEnable,
		PCEnable       => AuxPCEnable,
		AddrEnable     => AuxAddrEnable,
		IREnable       => AuxIREnable,
		Mux1Sel        => AuxMux1Sel,
		Mux2Sel        => AuxMux2Sel,
		Mux3Sel        => AuxMux3Sel,
		Mux4Sel        => AuxMux4Sel,
		Mux5Sel        => AuxMux5Sel,
		Mux6Sel        => AuxMux6Sel,
		AluOpSel       => AuxAluOpSel,
		MemWriteEnable => AuxMemWriteEnable,
		SignExpSel     => AuxSignExpSel,
		IRValue        => AuxIRValue,
		GPOut          => GPOut,
		Clk            => Clk,
		Reset          => Reset
	);
	FSM1 : FSM port map (
		DataOutEnable  => AuxDataOutEnable,
		DataInEnable   => AuxDataInEnable,
		RAEnable       => AuxRAEnable,
		RBEnable       => AuxRBEnable,
		RCEnable       => AuxRCEnable,
		SPEnable       => AuxSPEnable,
		PCEnable       => AuxPCEnable,
		AddrEnable     => AuxAddrEnable,
		IREnable       => AuxIREnable,
		Mux1Sel        => AuxMux1Sel,
		Mux2Sel        => AuxMux2Sel,
		Mux3Sel        => AuxMux3Sel,
		Mux4Sel        => AuxMux4Sel,
		Mux5Sel        => AuxMux5Sel,
		Mux6Sel        => AuxMux6Sel,
		AluOpSel       => AuxAluOpSel,
		MemWriteEnable => AuxMemWriteEnable,
		SignExpSel     => AuxSignExpSel,
		IRValue        => AuxIRValue,
		Clk            => Clk,
		Reset          => Reset
	);
end architecture;
